OGRE: Ogre::StaticGeometry::Region Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::StaticGeometry::Region Class Reference

The details of a topological region which is the highest level of partitioning for this class. More...

`#include <OgreStaticGeometry.h>`

Inheritance diagram for Ogre::StaticGeometry::Region:
[legend]

## Public Types
typedef std::vector< LODBucket * > | LODBucketList
| list of LOD Buckets in this region
typedef VectorIterator< LODBucketList > | LODIterator
Public Types inherited from Ogre::ShadowCaster
typedef Ogre::ShadowRenderableList | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator

## Public Member Functions
| Region (StaticGeometry *parent, const String &name, SceneManager *mgr, uint32 regionID, const Vector3 &centre)
virtual | ~Region ()
void | _notifyCurrentCamera (Camera *cam) override
| Internal method to notify the object of the camera to be used for the next rendering operation.
void | _releaseManualHardwareResources () override
| Notifies the movable object that hardware resources were lost.
void | _restoreManualHardwareResources () override
| Notifies the movable object that hardware resources should be restored.
void | _updateRenderQueue (RenderQueue *queue) override
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
void | assign (QueuedSubMesh *qmesh)
| Assign a queued mesh to this region, read for final build.
void | build (bool stencilShadows)
| Build this region.
const AxisAlignedBox & | getBoundingBox (void) const override
| Retrieves the local axis-aligned bounding box for this object.
Real | getBoundingRadius (void) const override
| Retrieves the radius of the origin-centered bounding sphere for this object.
const Vector3 & | getCentre (void) const
| Get the centre point of the region.
EdgeData * | getEdgeList (void) override
| Returns details of the edges which might be used to determine a silhouette.
uint32 | getID (void) const
| Get the region ID of this region.
const LODBucketList & | getLODBuckets () const
| Get an list of the LODs in this region.
LODIterator | getLODIterator (void)
const String & | getMovableType (void) const override
| Returns the type name of this object.
StaticGeometry * | getParent (void) const
const ShadowRenderableList & | getShadowVolumeRenderableList (const Light *light, const HardwareIndexBufferPtr &indexBuffer, size_t &indexBufferUsedSize, float extrusionDistance, int flags=0) override
| Gets an list of the renderables required to render the shadow volume.
uint32 | getTypeFlags (void) const override
| Get the 'type flags' for this MovableObject.
bool | isVisible (void) const override
| Returns whether or not this object is supposed to be visible or not.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false) override
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject ()
| Constructor.
| MovableObject (const String &name)
| Named constructor.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const Affine3 & | _getParentNodeFullTransform (void) const
| Return the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
Real | getBoundingRadiusScaled () const
| as getBoundingRadius, but with scaling applied
bool | getCastShadows (void) const override
| Returns whether shadow casting is enabled for this object.
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener (void) const
| Gets the current listener for this object.
const String & | getName (void) const
| Returns the name of this object.
Node * | getParentNode (void) const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
Real | getPointExtrusionDistance (const Light *l) const override
| Get the distance to extrude for a point/spot light.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const override
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::ShadowCaster
virtual | ~ShadowCaster ()
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
const AxisAlignedBox & | getLightCapBounds (void) const
| Gets the world space bounding box of the light cap.
bool | hasEdgeList ()
| Returns whether the object has a valid edge list.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
virtual const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::MovableObject
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
Static Public Member Functions inherited from Ogre::ShadowCaster
static void | clearShadowRenderableList (ShadowRenderableList &shadowRenderables)
| Common implementation of releasing shadow renderables.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.

## Detailed Description

The details of a topological region which is the highest level of partitioning for this class.

The size & shape of regions entirely depends on the SceneManager specific implementation. It is a MovableObject since it will be attached to a node based on the local centre - in practice it won't actually move (although in theory it could).

## Member Typedef Documentation

## ◆ LODBucketList

typedef std::vector<LODBucket*> Ogre::StaticGeometry::Region::LODBucketList

list of LOD Buckets in this region

## ◆ LODIterator

typedef VectorIterator<LODBucketList> Ogre::StaticGeometry::Region::LODIterator

## Constructor & Destructor Documentation

## ◆ Region()

Ogre::StaticGeometry::Region::Region | ( | StaticGeometry * | parent,
|  | const String & | name,
|  | SceneManager * | mgr,
|  | uint32 | regionID,
|  | const Vector3 & | centre )

References Ogre::StaticGeometry::StaticGeometry().

Referenced by operator<<.

## ◆ ~Region()

virtual Ogre::StaticGeometry::Region::~Region | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ getParent()

StaticGeometry * Ogre::StaticGeometry::Region::getParent | ( | void |  | ) | const
| inline

References Ogre::StaticGeometry::StaticGeometry().

## ◆ assign()

void Ogre::StaticGeometry::Region::assign | ( | QueuedSubMesh * | qmesh | ) |

Assign a queued mesh to this region, read for final build.

## ◆ build()

void Ogre::StaticGeometry::Region::build | ( | bool | stencilShadows | ) |

Build this region.

## ◆ getID()

uint32 Ogre::StaticGeometry::Region::getID | ( | void |  | ) | const
| inline

Get the region ID of this region.

## ◆ getCentre()

const Vector3 & Ogre::StaticGeometry::Region::getCentre | ( | void |  | ) | const
| inline

Get the centre point of the region.

## ◆ getMovableType()

const String & Ogre::StaticGeometry::Region::getMovableType | ( | void |  | ) | const
| overridevirtual

Returns the type name of this object.

Implements Ogre::MovableObject.

## ◆ _notifyCurrentCamera()

void Ogre::StaticGeometry::Region::_notifyCurrentCamera | ( | Camera * | cam | ) |
| overridevirtual

Internal method to notify the object of the camera to be used for the next rendering operation.

Certain objects may want to do specific processing based on the camera position. This method notifies them in case they wish to do this.

Reimplemented from Ogre::MovableObject.

## ◆ getBoundingBox()

const AxisAlignedBox & Ogre::StaticGeometry::Region::getBoundingBox | ( | void |  | ) | const
| overridevirtual

Retrieves the local axis-aligned bounding box for this object.

This bounding box is in local coordinates.

Implements Ogre::MovableObject.

## ◆ getBoundingRadius()

Real Ogre::StaticGeometry::Region::getBoundingRadius | ( | void |  | ) | const
| overridevirtual

Retrieves the radius of the origin-centered bounding sphere for this object.

Implements Ogre::MovableObject.

## ◆ _updateRenderQueue()

void Ogre::StaticGeometry::Region::_updateRenderQueue | ( | RenderQueue * | queue | ) |
| overridevirtual

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Implements Ogre::MovableObject.

## ◆ visitRenderables()

void Ogre::StaticGeometry::Region::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = false )
| overridevirtual

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters

  visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implements Ogre::MovableObject.

## ◆ isVisible()

bool Ogre::StaticGeometry::Region::isVisible | ( | void |  | ) | const
| overridevirtual

Returns whether or not this object is supposed to be visible or not.

Takes into account both upper rendering distance and visible flag.

Reimplemented from Ogre::MovableObject.

## ◆ getTypeFlags()

uint32 Ogre::StaticGeometry::Region::getTypeFlags | ( | void |  | ) | const
| overridevirtual

Get the 'type flags' for this MovableObject.

A type flag identifies the type of the MovableObject as a bitpattern. This is used for categorical inclusion / exclusion in SceneQuery objects. By default, this method returns all ones for objects not created by a MovableObjectFactory (hence always including them); otherwise it returns the value assigned to the MovableObjectFactory. Custom objects which don't use MovableObjectFactory will need to override this if they want to be included in queries.

Reimplemented from Ogre::MovableObject.

## ◆ getLODIterator()

LODIterator Ogre::StaticGeometry::Region::getLODIterator | ( | void |  | ) |

Deprecated
  use getLODBuckets()

## ◆ getLODBuckets()

const LODBucketList & Ogre::StaticGeometry::Region::getLODBuckets | ( |  | ) | const
| inline

Get an list of the LODs in this region.

## ◆ getShadowVolumeRenderableList()

const ShadowRenderableList & Ogre::StaticGeometry::Region::getShadowVolumeRenderableList | ( | const Light * | light,
|  | const HardwareIndexBufferPtr & | indexBuffer,
|  | size_t & | indexBufferUsedSize,
|  | float | extrusionDistance,
|  | int | flags = 0 )
| overridevirtual

Gets an list of the renderables required to render the shadow volume.

Shadowable geometry should ideally be designed such that there is only one ShadowRenderable required to render the the shadow; however this is not a necessary limitation and it can be exceeded if required.

Parameters

  light | The light to generate the shadow from.
  indexBuffer | The index buffer to build the renderables into, the current contents are assumed to be disposable.
  indexBufferUsedSize | If the rest of buffer is enough than it would be locked with HBL_NO_OVERWRITE semantic and indexBufferUsedSize would be increased, otherwise HBL_DISCARD would be used and indexBufferUsedSize would be reset.
  extrusionDistance | The distance to extrude the shadow volume.
  flags | Technique-specific flags, see ShadowRenderableFlags.

Reimplemented from Ogre::ShadowCaster.

## ◆ getEdgeList()

EdgeData * Ogre::StaticGeometry::Region::getEdgeList | ( | void |  | ) |
| overridevirtual

Returns details of the edges which might be used to determine a silhouette.

Reimplemented from Ogre::ShadowCaster.

## ◆ _releaseManualHardwareResources()

void Ogre::StaticGeometry::Region::_releaseManualHardwareResources | ( |  | ) |
| overridevirtual

Notifies the movable object that hardware resources were lost.

Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented from Ogre::MovableObject.

## ◆ _restoreManualHardwareResources()

void Ogre::StaticGeometry::Region::_restoreManualHardwareResources | ( |  | ) |
| overridevirtual

Notifies the movable object that hardware resources should be restored.

Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented from Ogre::MovableObject.

The documentation for this class was generated from the following file:

- OgreStaticGeometry.h